from fastapi import FastAPI

from .utils.email_code import smtp
from .router.signup import router as signup_router


app = FastAPI()
app.include_router(signup_router)


@app.on_event('shutdown')
def close_smtp():
    smtp.close()


@app.get('/')
async def main():
    return {'code': 10000, 'msg': 'hello world'}

