import random
from email.message import EmailMessage
from smtplib import SMTP, SMTPServerDisconnected

from .redis_api import redis_server

smtp = SMTP(host='smtp.office365.com')
smtp.ehlo()
smtp.starttls()
smtp.login('together_app@outlook.com', 'togetherno.1')


async def connect_email_server():
    try:
        smtp.noop()
    except SMTPServerDisconnected:
        smtp.connect(host='smtp.office365.com')
        smtp.ehlo()
        smtp.starttls()
        smtp.login('together_app@outlook.com', 'togetherno.1')


async def send_email(to: str):
    code = await generate_code(to)
    msg = EmailMessage()
    await connect_email_server()
    msg['Subject'] = 'Together app signup verification code'
    msg['From'] = 'TogetherApp <together_app@outlook.com>'
    msg['To'] = f'<{to}>'

    email_content = f'''\
    <html>
      <head></head>
      <body>
        <p>您的验证码是: <b>{code}</b></p>
        <br>
        <footer>邮件来自: <a>Together App</a></footer>
      </body>
    </html>
    '''

    msg.set_content(email_content)
    smtp.send_message(msg)
    smtp.quit()


async def generate_code(email: str) -> str:
    seed = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9']
    chosen_elements = random.choices(seed, k=6)
    code = ''.join(chosen_elements)
    redis_server.set(f'code:{email}', code, ex=60)
    return code
